<?php
namespace FM\Factory;

use Doctrine\ORM\EntityManager;

class CardsFactory
{
    
    protected $connection;
    
    public function __construct(EntityManager $entityManager) {
        
        $this->connection = $entityManager->getConnection();
    }

    public function buscaTipoLocal() {
        $sql = "SELECT NMTIPOLOCALCLI, NRTIPOLOCALCLI
                  FROM FCM_TIPOLOCALCLI";
        $std = $this->connection->prepare($sql);
        $std->execute();
        return $std->fetchAll();
    }

    public function buscaLocal() {
        $sql = "SELECT NRLOCALCLIENTE,NMLOCALCLIENTE
                  FROM FCM_LOCALCLI
                  WHERE NRLOCALCLIENTEPAI IS NOT NULL";
        $std = $this->connection->prepare($sql);
        $std->execute();
        return $std->fetchAll();
    }

    public function buscaChecklist() {
        $sql = "SELECT NRCHECKLIST, NMCHECKLIST
                  FROM FCM_CHECKLIST";
        $std = $this->connection->prepare($sql);
        $std->execute();
        return $std->fetchAll();
    }

    public function buscaItensChecklist($param) {
        $sql = "SELECT FCM_ATIVIDADECHK.NRATIVIDADECHK, FCM_ATIVIDADE.NMATIVIDADE 
                  FROM FCM_ATIVIDADE
                  JOIN FCM_ATIVIDADECHK
                    ON FCM_ATIVIDADE.NRATIVIDADE = FCM_ATIVIDADECHK.NRATIVIDADE
                  JOIN FCM_CHECKLIST
                    ON FCM_ATIVIDADECHK.NRCHECKLIST = FCM_CHECKLIST.NRCHECKLIST
                 WHERE FCM_CHECKLIST.NRCHECKLIST = ".$param['NRCHECKLIST'];
                
        $std = $this->connection->prepare($sql);
        $std->execute();
        return $std->fetchAll();
    }

    public function buscaFuncionario() {
        $sql = "SELECT FUNC.NRFUNCIONARIO, 
                       FUNC.NMFUNCIONARIO,
                       RELAC.NRPERFILACESSO
                FROM FCM_FUNCIONARIO FUNC
                JOIN FCM_RELACFUNCPERFACESS RELAC
                ON FUNC.NRFUNCIONARIO = RELAC.NRFUNCIONARIO
                JOIN FCM_PERFILACESSO PERF
                ON PERF.NRPERFILACESSO = RELAC.NRPERFILACESSO
                WHERE RELAC.NRPERFILACESSO != 12";
        $std = $this->connection->prepare($sql);
        $std->execute();
        return $std->fetchAll();
    }
    
    public function buscandoSupervisor() {
        $sql = "SELECT FUNC.NRFUNCIONARIO, 
                       FUNC.NMFUNCIONARIO,
                       RELAC.NRPERFILACESSO
                FROM FCM_FUNCIONARIO FUNC
                JOIN FCM_RELACFUNCPERFACESS RELAC
                ON FUNC.NRFUNCIONARIO = RELAC.NRFUNCIONARIO
                JOIN FCM_PERFILACESSO PERF
                ON PERF.NRPERFILACESSO = RELAC.NRPERFILACESSO
                WHERE RELAC.NRPERFILACESSO IN 12";
        $std = $this->connection->prepare($sql);
        $std->execute();
        return $std->fetchAll();
    }

    public function buscaCriterioTarefa($params) {
        $sql = "SELECT NRTAREFACHK, NMTAREFACHK
                  FROM FCM_TAREFACHK
                  WHERE NRCHECKLIST IN (".$params['NRCHECKLIST'].")";
        $std = $this->connection->prepare($sql);
        $std->execute();
        return $std->fetchAll();
    }
    
    public function buscaTarefa($params) {
        $sql = "SELECT A.NRTAREFACHK, C.NMTAREFA
                FROM FCM_TAREFACHK A
                JOIN FCM_ATIVIDADECHK B
                ON A.NRATIVIDADECHK = B.NRATIVIDADECHK
                JOIN FCM_TAREFA C
                ON A.NRTAREFA = C.NRTAREFA
                WHERE B.NRATIVIDADECHK IN (".$params['NRATIVIDADE'].")";
        $std = $this->connection->prepare($sql);
        $std->execute();
        return $std->fetchAll();
    }
    
    public function buscaCriterioAtividade($params){
        $sql = "SELECT A.NRCRITERIOTAREFACHK, A.NRCRITERIOTAREFA,B.DSCRITERIOTAREFA, A.NRTAREFACHK
                  FROM FCM_CRITERIOTAREFACHK A
                  JOIN FCM_CRITERIOTAREFA B
                ON A.NRCRITERIOTAREFA = B.NRCRITERIOTAREFA
                JOIN FCM_TAREFACHK C
                ON A.NRTAREFACHK = C.NRTAREFACHK
                JOIN FCM_ATIVIDADECHK D
                ON C.NRATIVIDADECHK = D.NRATIVIDADECHK
                JOIN FCM_CHECKLIST E
                ON E.NRCHECKLIST = D.NRCHECKLIST
                WHERE E.NRCHECKLIST = ".$params['NRCHECKLIST']."
                AND D.NRATIVIDADECHK IN (".$params['NRATIVIDADECHK'].")
                AND C.NRTAREFACHK IN (".$params['NRTAREFACHK'].")";
        $std = $this->connection->prepare($sql);
        $std->execute();
        return $std->fetchAll();
    }
    
    public function buscaCard($params, $hierarchyParam){
        $sql = "SELECT A.NRCHECKLISTAGEND, A.NMCHECKLISTAGEND, A.NRLOCALCLIENTE, C.NMLOCALCLIENTE, D.NMLOCALCLIENTE as NMLOCALCLIENTE2, D.NRLOCALCLIENTEPAI, C.NMLOCALCLIENTE || ' | ' || D.NMLOCALCLIENTE AS NMLOCAL,
        A.NRCHECKLIST, B.NMCHECKLIST, A.NRFUNCIONARIO, E.NMFUNCIONARIO, A.IDSITUACAOAGEND ,CASE A.IDSITUACAOAGEND 
            WHEN '1' THEN 'Pendente'
            WHEN '2' THEN 'Em Andamento'
            WHEN '3' THEN 'Concluido'
            WHEN '4' THEN 'Cancelado'
            ELSE NULL END AS NMIDSITUACAOAGEND, A.DTHORAAGEND
        FROM FCM_CHECKLISTAGEND A
        JOIN FCM_CHECKLIST B
        ON A.NRCHECKLIST = B.NRCHECKLIST
        JOIN FCM_LOCALCLI C
        ON A.NRLOCALCLIENTE = C.NRLOCALCLIENTE
        JOIN FCM_LOCALCLI D
        ON D.NRLOCALCLIENTE = C.NRLOCALCLIENTEPAI
        JOIN FCM_FUNCIONARIO E
        ON E.NRFUNCIONARIO = A.NRFUNCIONARIO 
            WHERE A.NRFUNCIONARIO IN ({$hierarchyParam}) ".$params['FILTRO'];
        
        $std = $this->connection->prepare($sql);
        $std->execute();
        return $std->fetchAll();
    }
    
    public function insertNovaTarefa($param){
        $sql="INSERT INTO FCM_CHECKLISTAGEND (NRCHECKLISTAGEND, NMCHECKLISTAGEND, NRLOCALCLIENTE, NRCHECKLIST, NRFUNCIONARIO, 
                                              IDSITUACAOAGEND, DTHORAAGEND,  IDATIVO, DTINCLUSAO, DTHRFINALAGEND,
                                              CDOPERINCLUSAO)
              VALUES (:NRCHECKLISTAGEND, :NMCHECKLISTAGEND, :NRLOCALCLIENTE, :NRCHECKLIST, :NRFUNCIONARIO, 
                      :IDSITUACAOAGEND,TO_DATE(:DTHORAAGEND,'YYYY/MM/DD HH24:MI'),  'S', SYSDATE, TO_DATE(:DTHRFINALAGEND,'YYYY/MM/DD HH24:MI'),
                      :OPERADOR)";
        $std = $this->connection->prepare($sql);
        $std->execute($param);
    }
    
    public function insertNovaTarefa2($param){
        $sql="INSERT INTO FCM_TAREFAAGEND (NRTAREFAAGEND, NRCHECKLISTAGEND, NRTAREFACHK, NRFUNCIONARIO, DTHORATAREFAAGEND, 
                                           DSOBSTAREFAAGEND, IDREALIZADO,  IDATIVO, DTINCLUSAO, 
                                           CDOPERINCLUSAO)
              VALUES (:NRTAREFAAGEND, :NRCHECKLISTAGEND, :NRTAREFACHK, :NRFUNCIONARIO, TO_DATE(:DTHORAAGEND,'YYYY/MM/DD HH24:MI'), 
                      :DSOBSTAREFAAGEND, 'N',  'S', SYSDATE, 
                      :OPERADOR)";
        $std = $this->connection->prepare($sql);
        $std->execute($param);
    }
    
    public function insertNovaTarefa3($param){
        $sql="INSERT INTO FCM_CRITERIOTARAGEND (NRCRITERIOTARAGEND, NMCRITERIOTARAGEND, NRTAREFAAGEND, NRCRITERIOTAREFACHK, IDATIVO,
                                                DTINCLUSAO, CDOPERINCLUSAO)
                                        VALUES (:NRCRITERIOTARAGEND,:NMCRITERIOTARAGEND, :NRTAREFAAGEND, :NRCRITERIOTAREFACHK, 'S',
                                                SYSDATE, :OPERADOR)";
        $std = $this->connection->prepare($sql);
        $std->execute($param);
    }
        
    public function insertNovaTarefa4($param){
        $sql="INSERT INTO FCM_GERENCIAMENTOCHK (NRGERENCIAMENTOCHK, NMGERENCIAMENTOCHK, NRLOCALCLIENTE, NRCHECKLIST, NRFUNCIONARIO, 
                             IDSITUACAOGERCHK, DTHORAAGEND, IDATIVO, DTINCLUSAO, 
                             CDOPERINCLUSAO, NRCHECKLISTAGEND,DTHRFINALAGEND)
       VALUES (:NRGERENCIAMENTOCHK, :NMGERENCIAMENTOCHK, :NRLOCALCLIENTE, :NRCHECKLIST, :NRFUNCIONARIO, 
                             '1',  :DTHORAAGEND, 'S', SYSDATE, 
                             :OPERADOR, :NRCHECKLISTAGEND,TO_DATE(:DTHRFINALAGEND,'YYYY/MM/DD HH24:MI'))";
                             
        $std = $this->connection->prepare($sql);
        $std->execute($param);
    }
    
    public function insertNovaTarefa5($param){
        $sql="INSERT INTO FCM_TAREFAGERCHK (NRTAREFAGERCHK, NRGERENCIAMENTOCHK, NRTAREFACHK, NRFUNCIONARIO, DTHORATAREFAGERCHK, 
                             DSOBSTAREFAGERCHK, IDATIVO, DTINCLUSAO,  CDOPERINCLUSAO)
       VALUES (:NRTAREFAGERCHK, :NRGERENCIAMENTOCHK, :NRTAREFACHK, :NRFUNCIONARIO, :DTHORATAREFAGERCHK, 
                             :DSOBSTAREFAGERCHK, 'S', SYSDATE, :OPERADOR)";
                             
        $std = $this->connection->prepare($sql);
        $std->execute($param);
    }
    public function insertNovaTarefa6($param){
        $sql="INSERT INTO FCM_CRITERIOTARGERCHK (NRCRITERIOTARGERCHK, NMCRITERIOTARGERCHK, NRTAREFAGERCHK, NRCRITERIOTAREFACHK, IDATIVO, 
                                DTINCLUSAO, CDOPERINCLUSAO)
       VALUES (:NRCRITERIOTARGERCHK, :NMCRITERIOTARGERCHK,:NRTAREFAGERCHK, :NRCRITERIOTAREFACHK,  'S', SYSDATE, :OPERADOR)";
                  
        $std = $this->connection->prepare($sql);
        $std->execute($param);
    }
}
?>