/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_SETORPROD                                                */
/* Tabela : SETORPRODUTO                                                      */
/*                                                                            */
/* Criao:                                                                   */
/* 26/01/2016 - Joao Marcelo Alves Leao                                       */
/*                                                                            */
/******************************************************************************/


CREATE OR REPLACE TRIGGER DTULTATU_SETORPROD
BEFORE INSERT OR UPDATE OR DELETE
ON SETORPRODUTO FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATU := SYSDATE;
      UPDATE SETORFILIAL
         SET DTULTATU = SYSDATE
       WHERE CDSETOR = :NEW.CDSETOR;
   END IF;
   IF UPDATING THEN
      :NEW.DTULTATU := SYSDATE;
      UPDATE SETORFILIAL
         SET DTULTATU = SYSDATE
       WHERE CDSETOR = :OLD.CDSETOR;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('SETORPRODUTO', '', 'CDPRODUTO='||:OLD.CDPRODUTO||';CDSETOR='||:OLD.CDSETOR||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE SETORPRODUTO MODIFY DTULTATU DEFAULT SYSDATE
/

-- VERSAO --
BEGIN ATUVEROBJ('DTULTATU_SETORPROD','5.85.XXX'); END;
/




